org.apache.bcel.classfile

## Class Signature

- java.lang.Object
- - org.apache.bcel.classfile.Attribute
  - - org.apache.bcel.classfile.Signature

- All Implemented Interfaces:
    Cloneable, Node

      public final class Signature
      extends Attribute

  This class is derived from Attribute and represents a reference to a GJ attribute.
  See Also:
    `Attribute`

- - ### Field Summary

    - ### Fields inherited from class org.apache.bcel.classfile.Attribute

      `constant_pool, length, name_index, tag`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Signature(int name_index, int length, int signatureIndex, ConstantPool constant_pool)`
    `Signature(Signature c)` Initialize from another object.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `accept(Visitor v)` Called by objects that are traversing the nodes of the tree implicitely defined by the contents of a Java class.
    `Attribute` | `copy(ConstantPool _constant_pool)`
    `void` | `dump(DataOutputStream file)` Dump source file attribute to file stream in binary format.
    `String` | `getSignature()`
    `int` | `getSignatureIndex()`
    `static boolean` | `isActualParameterList(String s)`
    `static boolean` | `isFormalParameterList(String s)`
    `void` | `setSignatureIndex(int signatureIndex)`
    `String` | `toString()`
    `static String` | `translate(String s)`

    - ### Methods inherited from class org.apache.bcel.classfile.Attribute

      `addAttributeReader, addAttributeReader, clone, getConstantPool, getLength, getName, getNameIndex, getTag, println, readAttribute, readAttribute, removeAttributeReader, setConstantPool, setLength, setNameIndex`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### Signature

          public Signature(Signature c)

      Initialize from another object. Note that both objects use the same references (shallow copy). Use clone() for a physical copy.

    - #### Signature

          public Signature(int name_index,
                           int length,
                           int signatureIndex,
                           ConstantPool constant_pool)

      Parameters:
        `name_index` - Index in constant pool to CONSTANT_Utf8
        `length` - Content length in bytes
        `signatureIndex` - Index in constant pool to CONSTANT_Utf8
        `constant_pool` - Array of constants

  - ### Method Detail

    - #### accept

          public void accept(Visitor v)

      Called by objects that are traversing the nodes of the tree implicitely defined by the contents of a Java class. I.e., the hierarchy of methods, fields, attributes, etc. spawns a tree of objects.
      Specified by:
        `accept` in interface `Node`
      Specified by:
        `accept` in class `Attribute`
      Parameters:
        `v` - Visitor object

    - #### dump

          public void dump(DataOutputStream file)
                    throws IOException

      Dump source file attribute to file stream in binary format.
      Overrides:
        `dump` in class `Attribute`
      Parameters:
        `file` - Output file stream
      Throws:
        `IOException`

    - #### getSignatureIndex

          public int getSignatureIndex()

      Returns:
        Index in constant pool of source file name.

    - #### setSignatureIndex

          public void setSignatureIndex(int signatureIndex)

      Parameters:
        `signatureIndex` - the index info the constant pool of this signature

    - #### getSignature

          public String getSignature()

      Returns:
        GJ signature.

    - #### translate

          public static String translate(String s)

    - #### isFormalParameterList

          public static boolean isFormalParameterList(String s)

    - #### isActualParameterList

          public static boolean isActualParameterList(String s)

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Attribute`
      Returns:
        String representation

    - #### copy

          public Attribute copy(ConstantPool _constant_pool)

      Specified by:
        `copy` in class `Attribute`
      Returns:
        deep copy of this attribute

Copyright © 2004–2020 The Apache Software Foundation. All rights reserved.